Modules
Advanced generation of single-diode parameters
Same goal as generateSingleDiodeDefault but accepts a full Module payload — letting you override solver constraints (shunt resistance, recombination parameter, series resistance, etc.) and tune the fit before persisting.
POST
/
Module
/
Generator
/
GenerateSingleDiodeParametersAdvanced
Advanced generation of single-diode parameters
curl --request POST \
--url https://api.plantpredict.terabase.energy/Module/Generator/GenerateSingleDiodeParametersAdvanced \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"status": 0,
"model": null,
"manufacturer": null,
"length": 0,
"width": 0,
"weight": null,
"defaultOrientation": 0,
"numberOfCellsInSeries": 108,
"numberOfCellsInParallel": 0,
"stcShortCircuitCurrent": 1.74930325831,
"stcOpenCircuitVoltage": 89.7052484312,
"stcmppCurrent": 1.58974185618,
"stcmppVoltage": 72.0381001714,
"stcMaxPower": 116.860092192,
"stcPowerTempCoef": -0.128399496065,
"stcShortCircuitCurrentTempCoef": 0.00212187434454,
"stcOpenCircuitVoltageTempCoef": -0.274848561159,
"stcEfficiency": 0,
"minTolerance": null,
"maxTolerance": null,
"cellTechnologyType": 6,
"constructionType": 0,
"faciality": 0,
"bifacialityFactor": null,
"transmissionFactor": null,
"backSideMismatch": null,
"dataSource": 7,
"lightInducedDegradation": 0,
"moduleQuality": 0,
"moduleMismatchCoefficient": 0,
"heatBalanceConvectiveCoef": 0,
"heatBalanceConductiveCoef": 0,
"sandiaConductiveCoef": 0,
"sandiaConvectiveCoef": 0,
"cellToModuleTempDiff": 0,
"saturationCurrentAtSTC": 3.189466358347338e-11,
"seriesResistanceAtSTC": 0.7179999999999995,
"shuntResistanceAtSTC": 1650,
"diodeIdealityFactorAtSTC": 1.322801785929346,
"exponentialDependencyOnShuntResistance": 5.5,
"darkShuntResistance": 17000,
"linearTempDependenceOnGamma": -1.1560769224999505,
"shortCircuitCurrentAtSTC": 1.74930325831,
"recombinationParameter": 1.7591999999999999,
"builtInVoltage": 0.9,
"bandgapVoltage": 1.5,
"linearTempDependenceOnIsc": 0,
"heatAbsorptionCoefAlphaT": 0,
"referenceIrradiance": 1000,
"referenceTemperature": 25,
"aGamma": null,
"bGamma": null,
"cGamma": null,
"dGamma": null,
"spectralResponse": 0,
"pvModel": 0,
"useDefaultSandiaIAM": false,
"useDefaultTabularIAM": false,
"sandiaSpectralA0": null,
"sandiaSpectralA1": null,
"sandiaSpectralA2": null,
"sandiaSpectralA3": null,
"sandiaSpectralA4": null,
"sandiaIAMB0": null,
"sandiaIAMB1": null,
"sandiaIAMB2": null,
"sandiaIAMB3": null,
"sandiaIAMB4": null,
"sandiaIAMB5": null,
"ashraeiamB0": 0.5,
"spectral2B0": null,
"spectral2B1": null,
"spectral2B2": null,
"spectral2B3": null,
"spectral2B4": null,
"spectral2B5": null,
"iamFactors": null,
"degradationModel": 0,
"linearDegradationRate": 0,
"nonLinearDegradationRates": null,
"effectiveIrradianceResponse": null,
"powerAtSTC": 0,
"lightGeneratedCurrent": 1.781409191869544,
"maximumSeriesResistance": 1.0359999999999991,
"maximumRecombinationParameter": 1.8879999999999997,
"id": 0,
"name": null,
"description": null,
"companyId": 0,
"company": null,
"ownerId": 0,
"owner": null,
"createdDate": "0001-01-01T00:00:00",
"lastModified": "0001-01-01T00:00:00",
"lastModifiedById": 0,
"lastModifiedBy": null
}
'import requests
url = "https://api.plantpredict.terabase.energy/Module/Generator/GenerateSingleDiodeParametersAdvanced"
payload = {
"status": 0,
"model": None,
"manufacturer": None,
"length": 0,
"width": 0,
"weight": None,
"defaultOrientation": 0,
"numberOfCellsInSeries": 108,
"numberOfCellsInParallel": 0,
"stcShortCircuitCurrent": 1.74930325831,
"stcOpenCircuitVoltage": 89.7052484312,
"stcmppCurrent": 1.58974185618,
"stcmppVoltage": 72.0381001714,
"stcMaxPower": 116.860092192,
"stcPowerTempCoef": -0.128399496065,
"stcShortCircuitCurrentTempCoef": 0.00212187434454,
"stcOpenCircuitVoltageTempCoef": -0.274848561159,
"stcEfficiency": 0,
"minTolerance": None,
"maxTolerance": None,
"cellTechnologyType": 6,
"constructionType": 0,
"faciality": 0,
"bifacialityFactor": None,
"transmissionFactor": None,
"backSideMismatch": None,
"dataSource": 7,
"lightInducedDegradation": 0,
"moduleQuality": 0,
"moduleMismatchCoefficient": 0,
"heatBalanceConvectiveCoef": 0,
"heatBalanceConductiveCoef": 0,
"sandiaConductiveCoef": 0,
"sandiaConvectiveCoef": 0,
"cellToModuleTempDiff": 0,
"saturationCurrentAtSTC": 3.189466358347338e-11,
"seriesResistanceAtSTC": 0.7179999999999995,
"shuntResistanceAtSTC": 1650,
"diodeIdealityFactorAtSTC": 1.322801785929346,
"exponentialDependencyOnShuntResistance": 5.5,
"darkShuntResistance": 17000,
"linearTempDependenceOnGamma": -1.1560769224999505,
"shortCircuitCurrentAtSTC": 1.74930325831,
"recombinationParameter": 1.7591999999999999,
"builtInVoltage": 0.9,
"bandgapVoltage": 1.5,
"linearTempDependenceOnIsc": 0,
"heatAbsorptionCoefAlphaT": 0,
"referenceIrradiance": 1000,
"referenceTemperature": 25,
"aGamma": None,
"bGamma": None,
"cGamma": None,
"dGamma": None,
"spectralResponse": 0,
"pvModel": 0,
"useDefaultSandiaIAM": False,
"useDefaultTabularIAM": False,
"sandiaSpectralA0": None,
"sandiaSpectralA1": None,
"sandiaSpectralA2": None,
"sandiaSpectralA3": None,
"sandiaSpectralA4": None,
"sandiaIAMB0": None,
"sandiaIAMB1": None,
"sandiaIAMB2": None,
"sandiaIAMB3": None,
"sandiaIAMB4": None,
"sandiaIAMB5": None,
"ashraeiamB0": 0.5,
"spectral2B0": None,
"spectral2B1": None,
"spectral2B2": None,
"spectral2B3": None,
"spectral2B4": None,
"spectral2B5": None,
"iamFactors": None,
"degradationModel": 0,
"linearDegradationRate": 0,
"nonLinearDegradationRates": None,
"effectiveIrradianceResponse": None,
"powerAtSTC": 0,
"lightGeneratedCurrent": 1.781409191869544,
"maximumSeriesResistance": 1.0359999999999991,
"maximumRecombinationParameter": 1.8879999999999997,
"id": 0,
"name": None,
"description": None,
"companyId": 0,
"company": None,
"ownerId": 0,
"owner": None,
"createdDate": "0001-01-01T00:00:00",
"lastModified": "0001-01-01T00:00:00",
"lastModifiedById": 0,
"lastModifiedBy": None
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
status: 0,
model: null,
manufacturer: null,
length: 0,
width: 0,
weight: null,
defaultOrientation: 0,
numberOfCellsInSeries: 108,
numberOfCellsInParallel: 0,
stcShortCircuitCurrent: 1.74930325831,
stcOpenCircuitVoltage: 89.7052484312,
stcmppCurrent: 1.58974185618,
stcmppVoltage: 72.0381001714,
stcMaxPower: 116.860092192,
stcPowerTempCoef: -0.128399496065,
stcShortCircuitCurrentTempCoef: 0.00212187434454,
stcOpenCircuitVoltageTempCoef: -0.274848561159,
stcEfficiency: 0,
minTolerance: null,
maxTolerance: null,
cellTechnologyType: 6,
constructionType: 0,
faciality: 0,
bifacialityFactor: null,
transmissionFactor: null,
backSideMismatch: null,
dataSource: 7,
lightInducedDegradation: 0,
moduleQuality: 0,
moduleMismatchCoefficient: 0,
heatBalanceConvectiveCoef: 0,
heatBalanceConductiveCoef: 0,
sandiaConductiveCoef: 0,
sandiaConvectiveCoef: 0,
cellToModuleTempDiff: 0,
saturationCurrentAtSTC: 3.189466358347338e-11,
seriesResistanceAtSTC: 0.7179999999999995,
shuntResistanceAtSTC: 1650,
diodeIdealityFactorAtSTC: 1.322801785929346,
exponentialDependencyOnShuntResistance: 5.5,
darkShuntResistance: 17000,
linearTempDependenceOnGamma: -1.1560769224999505,
shortCircuitCurrentAtSTC: 1.74930325831,
recombinationParameter: 1.7591999999999999,
builtInVoltage: 0.9,
bandgapVoltage: 1.5,
linearTempDependenceOnIsc: 0,
heatAbsorptionCoefAlphaT: 0,
referenceIrradiance: 1000,
referenceTemperature: 25,
aGamma: null,
bGamma: null,
cGamma: null,
dGamma: null,
spectralResponse: 0,
pvModel: 0,
useDefaultSandiaIAM: false,
useDefaultTabularIAM: false,
sandiaSpectralA0: null,
sandiaSpectralA1: null,
sandiaSpectralA2: null,
sandiaSpectralA3: null,
sandiaSpectralA4: null,
sandiaIAMB0: null,
sandiaIAMB1: null,
sandiaIAMB2: null,
sandiaIAMB3: null,
sandiaIAMB4: null,
sandiaIAMB5: null,
ashraeiamB0: 0.5,
spectral2B0: null,
spectral2B1: null,
spectral2B2: null,
spectral2B3: null,
spectral2B4: null,
spectral2B5: null,
iamFactors: null,
degradationModel: 0,
linearDegradationRate: 0,
nonLinearDegradationRates: null,
effectiveIrradianceResponse: null,
powerAtSTC: 0,
lightGeneratedCurrent: 1.781409191869544,
maximumSeriesResistance: 1.0359999999999991,
maximumRecombinationParameter: 1.8879999999999997,
id: 0,
name: null,
description: null,
companyId: 0,
company: null,
ownerId: 0,
owner: null,
createdDate: '0001-01-01T00:00:00',
lastModified: '0001-01-01T00:00:00',
lastModifiedById: 0,
lastModifiedBy: null
})
};
fetch('https://api.plantpredict.terabase.energy/Module/Generator/GenerateSingleDiodeParametersAdvanced', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"name": "<string>",
"model": "<string>",
"manufacturer": "<string>",
"stcMaxPower": 123,
"id": 123,
"description": "<string>",
"length": 123,
"width": 123,
"weight": 123,
"numberOfCellsInSeries": 123,
"numberOfCellsInParallel": 123,
"stcShortCircuitCurrent": 123,
"stcOpenCircuitVoltage": 123,
"stcmppCurrent": 123,
"stcmppVoltage": 123,
"stcPowerTempCoef": 123,
"stcShortCircuitCurrentTempCoef": 123,
"stcOpenCircuitVoltageTempCoef": 123,
"stcEfficiency": 123,
"minTolerance": 123,
"maxTolerance": 123,
"bifacialityFactor": 123,
"transmissionFactor": 123,
"backSideMismatch": 123,
"lightInducedDegradation": 123,
"moduleQuality": 123,
"moduleMismatchCoefficient": 123,
"heatBalanceConvectiveCoef": 123,
"heatBalanceConductiveCoef": 123,
"sandiaConductiveCoef": 123,
"sandiaConvectiveCoef": 123,
"cellToModuleTempDiff": 123,
"referenceIrradiance": 123,
"referenceTemperature": 123,
"linearDegradationRate": 123,
"effectiveIrradianceResponse": [
{}
],
"iamFactors": [
{}
],
"nonLinearDegradationRates": [
{}
]
}{
"message": "The request is invalid.",
"modelState": {
"latitude": [
"The field Latitude must be between -90 and 90."
]
}
}"An error has occurred."Authorizations
Pass Authorization: Bearer <token> on every request. See the Authentication section of the API description for how to fetch a token.
Body
application/json
Wp
LibraryStatusEnum
Available options:
0, 1, 2, 3, 4, 5, 6 mm
mm
kg
ModuleOrientation
Available options:
0, 1 CellTechnologyTypeEnum
Available options:
1, 2, 3, 4, 5, 6, 7, 8 CellDesignType
Available options:
0, 1, 2, 3 ConstructionTypeEnum
Available options:
1, 2 FacialityEnum
Available options:
0, 1 DataSourceType
Available options:
1, 2, 3, 4, 5, 6, 7 PvModelType
Available options:
0, 1, 3 ModuleDegradationModel
Available options:
0, 1, 2 Response
Module with generated parameters
Wp
LibraryStatusEnum
Available options:
0, 1, 2, 3, 4, 5, 6 mm
mm
kg
ModuleOrientation
Available options:
0, 1 CellTechnologyTypeEnum
Available options:
1, 2, 3, 4, 5, 6, 7, 8 CellDesignType
Available options:
0, 1, 2, 3 ConstructionTypeEnum
Available options:
1, 2 FacialityEnum
Available options:
0, 1 DataSourceType
Available options:
1, 2, 3, 4, 5, 6, 7 PvModelType
Available options:
0, 1, 3 ModuleDegradationModel
Available options:
0, 1, 2 ⌘I
Advanced generation of single-diode parameters
